# Save flag level impact metrics configuration POST https://app.unleash-instance.example.com/api/admin/projects/{projectId}/features/{featureName}/impact-metrics/config Content-Type: application/json **Enterprise feature** Saves a configuration for an impact metric chart associated with a feature flag. Reference: https://docs.getunleash.io/api/save-feature-impact-metrics-config ## OpenAPI Specification ```yaml openapi: 3.1.1 info: title: Save flag level impact metrics configuration version: endpoint_unstable.saveFeatureImpactMetricsConfig paths: /api/admin/projects/{projectId}/features/{featureName}/impact-metrics/config: post: operationId: save-feature-impact-metrics-config summary: Save flag level impact metrics configuration description: >- **Enterprise feature** Saves a configuration for an impact metric chart associated with a feature flag. tags: - - subpackage_unstable parameters: - name: projectId in: path required: true schema: type: string - name: featureName in: path required: true schema: type: string - name: Authorization in: header description: Header authentication of the form `undefined ` required: true schema: type: string responses: '200': description: impactMetricsConfigSchema content: application/json: schema: $ref: '#/components/schemas/impactMetricsConfigSchema' '401': description: >- Authorization information is missing or invalid. Provide a valid API token as the `authorization` header, e.g. `authorization:*.*.my-admin-token`. content: {} '403': description: >- The provided user credentials are valid, but the user does not have the necessary permissions to perform this operation content: {} '404': description: The requested resource was not found. content: {} requestBody: description: createImpactMetricsConfigSchema content: application/json: schema: $ref: '#/components/schemas/createImpactMetricsConfigSchema' components: schemas: CreateImpactMetricsConfigSchemaTimeRange: type: string enum: - value: hour - value: day - value: week - value: month CreateImpactMetricsConfigSchemaYAxisMin: type: string enum: - value: auto - value: zero CreateImpactMetricsConfigSchemaAggregationMode: type: string enum: - value: rps - value: count - value: avg - value: sum - value: p95 - value: p99 - value: p50 createImpactMetricsConfigSchema: type: object properties: id: type: string description: >- The unique ULID identifier for this impact metric configuration. Generated automatically if not provided. metricName: type: string description: >- The Prometheus metric series to query. It includes both unleash prefix and metric type and display name timeRange: $ref: '#/components/schemas/CreateImpactMetricsConfigSchemaTimeRange' description: The time range for the metric data. yAxisMin: $ref: '#/components/schemas/CreateImpactMetricsConfigSchemaYAxisMin' description: Whether the chart should begin at zero on the y-axis. aggregationMode: $ref: '#/components/schemas/CreateImpactMetricsConfigSchemaAggregationMode' description: The aggregation mode for the metric data. labelSelectors: type: object additionalProperties: type: array items: type: string description: The selected labels and their values for filtering the metric data. title: type: string description: Optional title for the impact metric chart. required: - metricName - timeRange - yAxisMin - aggregationMode - labelSelectors ImpactMetricsConfigSchemaTimeRange: type: string enum: - value: hour - value: day - value: week - value: month ImpactMetricsConfigSchemaAggregationMode: type: string enum: - value: rps - value: count - value: avg - value: sum - value: p95 - value: p99 - value: p50 ImpactMetricsConfigSchemaType: type: string enum: - value: counter - value: gauge - value: histogram - value: unknown ImpactMetricsConfigSchemaYAxisMin: type: string enum: - value: auto - value: zero ImpactMetricsConfigSchemaStep: type: string enum: - value: 1m - value: 15m - value: 3h - value: 1d ImpactMetricsConfigSchemaMode: type: string enum: - value: read - value: write impactMetricsConfigSchema: type: object properties: id: type: string description: >- The unique ULID identifier for this impact metric configuration. Generated automatically if not provided. metricName: type: string description: >- The Prometheus metric series to query. It includes both unleash prefix and metric type and display name timeRange: $ref: '#/components/schemas/ImpactMetricsConfigSchemaTimeRange' description: The time range for the metric data. aggregationMode: $ref: '#/components/schemas/ImpactMetricsConfigSchemaAggregationMode' description: The aggregation mode for the metric data. labelSelectors: type: object additionalProperties: type: array items: type: string description: The selected labels and their values for filtering the metric data. type: $ref: '#/components/schemas/ImpactMetricsConfigSchemaType' description: The type of metric displayName: type: string description: The human readable display name of the impact metric yAxisMin: $ref: '#/components/schemas/ImpactMetricsConfigSchemaYAxisMin' description: Whether the chart should begin at zero on the y-axis. step: oneOf: - $ref: '#/components/schemas/ImpactMetricsConfigSchemaStep' - type: 'null' description: >- The step interval for querying metrics data. This is automatically calculated from the timeRange and stored when the metric is created or updated. title: type: string description: Optional title for the impact metric chart. mode: $ref: '#/components/schemas/ImpactMetricsConfigSchemaMode' description: >- The access mode for this impact metric configuration: "read" when referenced by a safeguard, "write" otherwise. required: - id - metricName - timeRange - aggregationMode - labelSelectors - type - displayName - yAxisMin ``` ## SDK Code Examples ```python import requests url = "https://app.unleash-instance.example.com/api/admin/projects/projectId/features/featureName/impact-metrics/config" payload = { "metricName": "unleash_counter_feature_toggle_usage_total", "timeRange": "day", "yAxisMin": "auto", "aggregationMode": "rps", "labelSelectors": { "environment": ["development"], "project": ["default"] } } headers = { "Authorization": "", "Content-Type": "application/json" } response = requests.post(url, json=payload, headers=headers) print(response.json()) ``` ```javascript const url = 'https://app.unleash-instance.example.com/api/admin/projects/projectId/features/featureName/impact-metrics/config'; const options = { method: 'POST', headers: {Authorization: '', 'Content-Type': 'application/json'}, body: '{"metricName":"unleash_counter_feature_toggle_usage_total","timeRange":"day","yAxisMin":"auto","aggregationMode":"rps","labelSelectors":{"environment":["development"],"project":["default"]}}' }; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go package main import ( "fmt" "strings" "net/http" "io" ) func main() { url := "https://app.unleash-instance.example.com/api/admin/projects/projectId/features/featureName/impact-metrics/config" payload := strings.NewReader("{\n \"metricName\": \"unleash_counter_feature_toggle_usage_total\",\n \"timeRange\": \"day\",\n \"yAxisMin\": \"auto\",\n \"aggregationMode\": \"rps\",\n \"labelSelectors\": {\n \"environment\": [\n \"development\"\n ],\n \"project\": [\n \"default\"\n ]\n }\n}") req, _ := http.NewRequest("POST", url, payload) req.Header.Add("Authorization", "") req.Header.Add("Content-Type", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby require 'uri' require 'net/http' url = URI("https://app.unleash-instance.example.com/api/admin/projects/projectId/features/featureName/impact-metrics/config") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Post.new(url) request["Authorization"] = '' request["Content-Type"] = 'application/json' request.body = "{\n \"metricName\": \"unleash_counter_feature_toggle_usage_total\",\n \"timeRange\": \"day\",\n \"yAxisMin\": \"auto\",\n \"aggregationMode\": \"rps\",\n \"labelSelectors\": {\n \"environment\": [\n \"development\"\n ],\n \"project\": [\n \"default\"\n ]\n }\n}" response = http.request(request) puts response.read_body ``` ```java import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.post("https://app.unleash-instance.example.com/api/admin/projects/projectId/features/featureName/impact-metrics/config") .header("Authorization", "") .header("Content-Type", "application/json") .body("{\n \"metricName\": \"unleash_counter_feature_toggle_usage_total\",\n \"timeRange\": \"day\",\n \"yAxisMin\": \"auto\",\n \"aggregationMode\": \"rps\",\n \"labelSelectors\": {\n \"environment\": [\n \"development\"\n ],\n \"project\": [\n \"default\"\n ]\n }\n}") .asString(); ``` ```php request('POST', 'https://app.unleash-instance.example.com/api/admin/projects/projectId/features/featureName/impact-metrics/config', [ 'body' => '{ "metricName": "unleash_counter_feature_toggle_usage_total", "timeRange": "day", "yAxisMin": "auto", "aggregationMode": "rps", "labelSelectors": { "environment": [ "development" ], "project": [ "default" ] } }', 'headers' => [ 'Authorization' => '', 'Content-Type' => 'application/json', ], ]); echo $response->getBody(); ``` ```csharp using RestSharp; var client = new RestClient("https://app.unleash-instance.example.com/api/admin/projects/projectId/features/featureName/impact-metrics/config"); var request = new RestRequest(Method.POST); request.AddHeader("Authorization", ""); request.AddHeader("Content-Type", "application/json"); request.AddParameter("application/json", "{\n \"metricName\": \"unleash_counter_feature_toggle_usage_total\",\n \"timeRange\": \"day\",\n \"yAxisMin\": \"auto\",\n \"aggregationMode\": \"rps\",\n \"labelSelectors\": {\n \"environment\": [\n \"development\"\n ],\n \"project\": [\n \"default\"\n ]\n }\n}", ParameterType.RequestBody); IRestResponse response = client.Execute(request); ``` ```swift import Foundation let headers = [ "Authorization": "", "Content-Type": "application/json" ] let parameters = [ "metricName": "unleash_counter_feature_toggle_usage_total", "timeRange": "day", "yAxisMin": "auto", "aggregationMode": "rps", "labelSelectors": [ "environment": ["development"], "project": ["default"] ] ] as [String : Any] let postData = JSONSerialization.data(withJSONObject: parameters, options: []) let request = NSMutableURLRequest(url: NSURL(string: "https://app.unleash-instance.example.com/api/admin/projects/projectId/features/featureName/impact-metrics/config")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "POST" request.allHTTPHeaderFields = headers request.httpBody = postData as Data let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ```